package com.farecompare.jboss7example.relay.impl;

import com.farecompare.jboss7example.relay.api.RelayModuleAPI;
import com.farecompare.jboss7example.server.api.LocationModuleAPI;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Hashtable;

/**
 * Created by IntelliJ IDEA.
 * User: graemewallace
 * Date: 5/8/12
 * Time: 1:59 PM
 * To change this template use File | Settings | File Templates.
 */
public class RelayModule implements RelayModuleAPI {

    private final static Log _log = LogFactory.getLog(RelayModule.class);

    private static String _jndiName = "ejb:locationmodule/farecompare-locationmodule-ejb/LocationModuleSessionBean!com.farecompare.jboss7example.server.api.LocationModuleAPI";
    private LocationModuleAPI _locationModule;


    public RelayModule() {
        final Hashtable jndiProperties = new Hashtable();
        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");

        try {
            InitialContext context = new InitialContext(jndiProperties);

            _locationModule = (LocationModuleAPI) context.lookup(_jndiName);
        }
        catch (NamingException ne) {
            _log.error("Failed to do lookup", ne);
        }
    }

    public String getNameForCityCode(String cityCode) {
        if (_locationModule != null) return _locationModule.getCityName(cityCode);
        return null;
    }
}
