package com.farecompare.jboss7example.relay.util;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.ejb.client.ClusterNodeSelector;

import java.util.Arrays;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * Created by IntelliJ IDEA.
 * User: graemewallace
 * Date: 5/8/12
 * Time: 10:22 PM
 * To change this template use File | Settings | File Templates.
 */
public class RoundRobinClusterNodeSelector implements ClusterNodeSelector {

    private final static Log _log = LogFactory.getLog(RoundRobinClusterNodeSelector.class);

    private AtomicInteger _nodeIndex;

    public RoundRobinClusterNodeSelector() {
        _nodeIndex = new AtomicInteger(0);
    }

    public String selectNode(String clusterName, String[] connectedNodes, String[] availableNodes) {
        _log.info("RoundRobin::selectNode " + clusterName + " ConnectedNodes: " + Arrays.asList(connectedNodes) + " AvailableNodes: " + Arrays.asList(availableNodes));

        int nodeIdx;

        if (availableNodes.length < 2) {
            nodeIdx = 0;
        }
        else {
            nodeIdx = _nodeIndex.getAndIncrement() % availableNodes.length;
        }

        _log.info("RoundRobin::selectNode chose " + availableNodes[nodeIdx]);

        return availableNodes[nodeIdx];
    }
}
